=== userland/modules/Makefile ===

default: install

install:
	cd Endace; ./configure; make install
	#cd Netcope; ./configure; make install
	#cd Exablaze; ./configure; make install
	#cd Inveatech; ./configure; make install
	#cd Mellanox; ./configure; make install

clean:
	cd Endace; make clean
	#cd Netcope; make clean
	#cd Exablaze; make clean
	#cd Inveatech; make clean
	#cd Mellanox; make clean
